diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java b/src/main/java/net/minecraft/client/render/block/model/StandardBlockModel.java
similarity index 94%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
rename to src/main/java/net/minecraft/client/render/block/model/StandardBlockModel.java
index d55d6fa2f..e758362a3 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelStandard.java
+++ b/src/main/java/net/minecraft/client/render/block/model/StandardBlockModel.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.core.block.Block;
@@ -11,14 +11,14 @@ import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelStandard<T extends Block> extends BlockModel<T>{
+public class StandardBlockModel<T extends Block> extends BlockModel<T>{
     public static final IconCoordinate BLOCK_TEXTURE_MISSING = TextureRegistry.getTexture("minecraft:block/texture_missing");
     public static final IconCoordinate BLOCK_TEXTURE_UNASSIGNED = TextureRegistry.getTexture("minecraft:block/texture_unassigned");
     public IconCoordinate[] atlasIndices = new IconCoordinate[]{BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED, BLOCK_TEXTURE_UNASSIGNED};
     public double[] itemRenderBounds = null;
     public IconCoordinate overbrightTexture = null;
 
-    public BlockModelStandard(Block block) {
+    public StandardBlockModel(Block block) {
         super(block);
     }
 
@@ -251,26 +251,26 @@ public class BlockModelStandard<T extends Block> extends BlockModel<T>{
             itemRenderBounds[5]);
         }
     }
-    public BlockModelStandard<T> withCustomItemBounds(double minX, double minY, double minZ, double maxX, double maxY, double maxZ){
+    public StandardBlockModel<T> withCustomItemBounds(double minX, double minY, double minZ, double maxX, double maxY, double maxZ){
         this.itemRenderBounds = new double[]{minX, minY, minZ, maxX, maxY, maxZ};
         return this;
     }
-    public BlockModelStandard<T> withOverbrightTexture(String texture)
+    public StandardBlockModel<T> withOverbrightTexture(String texture)
     {
         this.hasOverbright = true;
         this.overbrightTexture = TextureRegistry.getTexture(texture);
         return this;
     }
-    public BlockModelStandard<T> withTextures(String texture){
+    public StandardBlockModel<T> withTextures(String texture){
         return withTextures(texture, texture, texture);
     }
-    public BlockModelStandard<T> withTextures(String textureTopBottom, String textureSides){
+    public StandardBlockModel<T> withTextures(String textureTopBottom, String textureSides){
         return withTextures(textureTopBottom, textureTopBottom, textureSides);
     }
-    public BlockModelStandard<T> withTextures(String textureTop, String textureBottom, String textureSides){
+    public StandardBlockModel<T> withTextures(String textureTop, String textureBottom, String textureSides){
         return withTextures(textureTop, textureBottom, textureSides, textureSides, textureSides, textureSides);
     }
-    public BlockModelStandard<T> withTextures(String textureTop, String textureBottom, String textureNorth, String textureEast, String textureSouth, String textureWest){
+    public StandardBlockModel<T> withTextures(String textureTop, String textureBottom, String textureNorth, String textureEast, String textureSouth, String textureWest){
         atlasIndices[Side.TOP.getId()] = TextureRegistry.getTexture(textureTop);
         atlasIndices[Side.BOTTOM.getId()] = TextureRegistry.getTexture(textureBottom);
         atlasIndices[Side.NORTH.getId()] = TextureRegistry.getTexture(textureNorth);
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java b/src/main/java/net/minecraft/client/render/block/model/TorchBlockModel.java
similarity index 96%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
rename to src/main/java/net/minecraft/client/render/block/model/TorchBlockModel.java
index b76c4bb37..9d980568d 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelTorch.java
+++ b/src/main/java/net/minecraft/client/render/block/model/TorchBlockModel.java
@@ -1,13 +1,13 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelTorch<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelTorch(Block block) {
+public class TorchBlockModel<T extends Block> extends StandardBlockModel<T> {
+    public TorchBlockModel(Block block) {
         super(block);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelTorchRedstone.java b/src/main/java/net/minecraft/client/render/block/model/TorchRedstoneBlockModel.java
similarity index 61%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelTorchRedstone.java
rename to src/main/java/net/minecraft/client/render/block/model/TorchRedstoneBlockModel.java
index bdd35d453..7b65a424e 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelTorchRedstone.java
+++ b/src/main/java/net/minecraft/client/render/block/model/TorchRedstoneBlockModel.java
@@ -1,14 +1,15 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockRedstoneTorch;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.RedstoneTorchBlock;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelTorchRedstone extends BlockModelTorch<BlockRedstoneTorch>{
-    private static final BlockModel<Block> redstoneWire = BlockModelDispatcher.getInstance().getDispatch(Block.wireRedstone);
+public class TorchRedstoneBlockModel extends TorchBlockModel<RedstoneTorchBlock> {
+    private static final BlockModel<Block> redstoneWire = BlockModelDispatcher.getInstance().getDispatch(Blocks.WIRE_REDSTONE);
 
-    public BlockModelTorchRedstone(Block block) {
+    public TorchRedstoneBlockModel(Block block) {
         super(block);
     }
 
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java b/src/main/java/net/minecraft/client/render/block/model/TransparentBlockModel.java
similarity index 80%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java
rename to src/main/java/net/minecraft/client/render/block/model/TransparentBlockModel.java
index b0a2d9837..a84a0b405 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelTransparent.java
+++ b/src/main/java/net/minecraft/client/render/block/model/TransparentBlockModel.java
@@ -3,9 +3,9 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelTransparent<T extends Block> extends BlockModelStandard<T> {
+public class TransparentBlockModel<T extends Block> extends StandardBlockModel<T> {
     private final boolean renderInside;
-    public BlockModelTransparent(Block block, boolean renderInside){
+    public TransparentBlockModel(Block block, boolean renderInside){
         super(block);
         this.renderInside = renderInside;
     }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java b/src/main/java/net/minecraft/client/render/block/model/TrapDoorBlockModel.java
similarity index 87%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
rename to src/main/java/net/minecraft/client/render/block/model/TrapDoorBlockModel.java
index 915854edd..91d6bef12 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoor.java
+++ b/src/main/java/net/minecraft/client/render/block/model/TrapDoorBlockModel.java
@@ -1,17 +1,17 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockTrapDoor;
+import net.minecraft.core.block.TrapDoorBlock;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelTrapDoor<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelTrapDoor(Block block) {
+public class TrapDoorBlockModel<T extends Block> extends StandardBlockModel<T> {
+    public TrapDoorBlockModel(Block block) {
         super(block);
         float offset = 0.1875F;
         withCustomItemBounds(0.0F, 0.0F, 0.0F, 1.0F, offset, 1.0F);
@@ -21,7 +21,7 @@ public class BlockModelTrapDoor<T extends Block> extends BlockModelStandard<T> {
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int metadata = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
-        boolean isUp = BlockTrapDoor.isTrapdoorOpen(metadata);
+        boolean isUp = TrapDoorBlock.isTrapdoorOpen(metadata);
 
         if(isUp) {
             switch (metadata & 3) {
@@ -55,7 +55,7 @@ public class BlockModelTrapDoor<T extends Block> extends BlockModelStandard<T> {
             }
         }
         else{
-            if(BlockTrapDoor.isUpperHalf(metadata)){
+            if(TrapDoorBlock.isUpperHalf(metadata)){
                 renderBlocks.uvRotateSouth = 3;
                 renderBlocks.uvRotateNorth = 3;
                 renderBlocks.uvRotateEast = 3;
@@ -75,7 +75,7 @@ public class BlockModelTrapDoor<T extends Block> extends BlockModelStandard<T> {
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         int orientation = data & 3;
-        if(BlockTrapDoor.isTrapdoorOpen(data)) {
+        if(TrapDoorBlock.isTrapdoorOpen(data)) {
             int index = Sides.orientationLookUpTrapdoorOpen[6 * orientation + side.getId()];
             return atlasIndices[index];
         } else {
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoorPainted.java b/src/main/java/net/minecraft/client/render/block/model/TrapDoorPaintedBlockModel.java
similarity index 52%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoorPainted.java
rename to src/main/java/net/minecraft/client/render/block/model/TrapDoorPaintedBlockModel.java
index f690e2511..69da98a57 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelTrapDoorPainted.java
+++ b/src/main/java/net/minecraft/client/render/block/model/TrapDoorPaintedBlockModel.java
@@ -1,33 +1,33 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.stitcher.IconCoordinate;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockTrapDoor;
-import net.minecraft.core.item.ItemDye;
+import net.minecraft.core.block.TrapDoorBlock;
 import net.minecraft.core.util.helper.Axis;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
 
-public class BlockModelTrapDoorPainted<T extends Block> extends BlockModelTrapDoor<T> {
-    public static final IconCoordinate[] topTextures = new IconCoordinate[16];
-    public static final IconCoordinate[] sideTextures = new IconCoordinate[16];
+public class TrapDoorPaintedBlockModel<T extends Block> extends TrapDoorBlockModel<T> {
+    public static final IconCoordinate[] topTextures = new IconCoordinate[DyeColor.COLOR_AMOUNT];
+    public static final IconCoordinate[] sideTextures = new IconCoordinate[DyeColor.COLOR_AMOUNT];
 
     static {
-        for(int i = 0; i < 16; i++) {
-            topTextures[i] = TextureRegistry.getTexture("minecraft:block/trapdoor_planks_oak_" + ItemDye.dyeColors[15 - i] + "_top");
-            sideTextures[i] = TextureRegistry.getTexture("minecraft:block/trapdoor_planks_oak_" + ItemDye.dyeColors[15 - i] + "_side");
+        for (DyeColor c : DyeColor.blockOrderedColors()){
+            topTextures[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/trapdoor_planks_oak_" + c.colorID + "_top");
+            sideTextures[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/trapdoor_planks_oak_" + c.colorID + "_side");
         }
     }
-    public BlockModelTrapDoorPainted(Block block) {
+    public TrapDoorPaintedBlockModel(Block block) {
         super(block);
     }
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
-        int color = (data >> 4) & 0xF;
+        int color = (data >> 4) & DyeColor.MASK_COLOR;
         int orientation = data & 3;
-        if(BlockTrapDoor.isTrapdoorOpen(data)) {
+        if(TrapDoorBlock.isTrapdoorOpen(data)) {
             int index = Sides.orientationLookUpTrapdoorOpen[6 * orientation + side.getId()];
             if (index < 2) return topTextures[color];
             return sideTextures[color];
diff --git a/src/main/java/net/minecraft/client/render/block/model/WoolBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/WoolBlockModel.java
new file mode 100644
index 000000000..946b878f3
--- /dev/null
+++ b/src/main/java/net/minecraft/client/render/block/model/WoolBlockModel.java
@@ -0,0 +1,25 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.Side;
+
+public class WoolBlockModel<T extends Block> extends StandardBlockModel<T> {
+    public static final IconCoordinate[] texCoords = new IconCoordinate[DyeColor.COLOR_AMOUNT];
+
+    static {
+        for (DyeColor c : DyeColor.blockOrderedColors()){
+            texCoords[c.blockMeta] = TextureRegistry.getTexture("minecraft:block/wool_" + c.colorID);
+        }
+    }
+    public WoolBlockModel(Block block) {
+        super(block);
+    }
+
+    @Override
+    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
+        return texCoords[data & DyeColor.MASK_COLOR];
+    }
+}
diff --git a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java b/src/main/java/net/minecraft/client/render/blockentity/BlockEntityRenderer.java
similarity index 60%
rename from src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java
rename to src/main/java/net/minecraft/client/render/blockentity/BlockEntityRenderer.java
index 033d5ba10..bd9dd308a 100644
--- a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java
+++ b/src/main/java/net/minecraft/client/render/blockentity/BlockEntityRenderer.java
@@ -1,16 +1,16 @@
-package net.minecraft.client.render.tileentity;
+package net.minecraft.client.render.blockentity;
 
 import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.RenderEngine;
-import net.minecraft.client.render.TileEntityRenderDispatcher;
+import net.minecraft.client.render.BlockEntityRenderDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.world.World;
 
-public abstract class TileEntityRenderer<T extends TileEntity>
+public abstract class BlockEntityRenderer<T extends BlockEntity>
 {
 
-    public TileEntityRenderer()
+    public BlockEntityRenderer()
     {
     }
 
@@ -20,10 +20,10 @@ public abstract class TileEntityRenderer<T extends TileEntity>
     protected void loadTexture(String texturePath)
     {
         RenderEngine renderengine = renderDispatcher.renderEngine;
-        renderengine.bindTexture(renderengine.getTexture(texturePath));
+        renderengine.bindTexture(renderengine.loadTexture(texturePath));
     }
 
-    public void setRenderDispatcher(TileEntityRenderDispatcher renderDispatcher)
+    public void setRenderDispatcher(BlockEntityRenderDispatcher renderDispatcher)
     {
         this.renderDispatcher = renderDispatcher;
     }
@@ -37,5 +37,5 @@ public abstract class TileEntityRenderer<T extends TileEntity>
         return renderDispatcher.getFontRenderer();
     }
 
-    protected TileEntityRenderDispatcher renderDispatcher;
+    protected BlockEntityRenderDispatcher renderDispatcher;
 }
diff --git a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java b/src/main/java/net/minecraft/client/render/blockentity/FlagBlockEntityRenderer.java
similarity index 72%
rename from src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java
rename to src/main/java/net/minecraft/client/render/blockentity/FlagBlockEntityRenderer.java
index 3c473cf82..824274de5 100644
--- a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java
+++ b/src/main/java/net/minecraft/client/render/blockentity/FlagBlockEntityRenderer.java
@@ -1,35 +1,35 @@
-package net.minecraft.client.render.tileentity;
+package net.minecraft.client.render.blockentity;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.FlagRenderer;
-import net.minecraft.client.render.model.ModelFlag;
+import net.minecraft.client.render.model.FlagModel;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.block.Block;
-import net.minecraft.core.block.entity.TileEntityFlag;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.FlagBlockEntity;
 
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.wind.WindManager;
+import net.minecraft.core.world.wind.WindProvider;
 import org.lwjgl.opengl.GL11;
 
-public class TileEntityRendererFlag extends TileEntityRenderer<TileEntityFlag>
+public class FlagBlockEntityRenderer extends BlockEntityRenderer<FlagBlockEntity>
 {
 
 	public final Minecraft mc = Minecraft.getMinecraft(this);
-    private final ModelFlag flagModel;
+    private final FlagModel flagModel;
     private FlagRenderer flagRenderer = null;
     
-    public TileEntityRendererFlag() 
+    public FlagBlockEntityRenderer()
     {
-        flagModel = new ModelFlag();
+        flagModel = new FlagModel();
     }
 
     @Override
-    public void doRender(Tessellator tessellator, TileEntityFlag tileEntity, double x, double y, double z, float partialTick) {
+    public void doRender(Tessellator tessellator, FlagBlockEntity tileEntity, double x, double y, double z, float partialTick) {
         World theWorld = Minecraft.getMinecraft(this).theWorld;
         int blockUnder = theWorld.getBlockId(tileEntity.x, tileEntity.y - 1, tileEntity.z);
-        boolean shortPole = blockUnder == Block.flag.id;
+        boolean shortPole = blockUnder == Blocks.FLAG.id;
 
-        WindManager theWind = mc.theWorld.getWorldType().getWindManager();
+        WindProvider theWind = mc.theWorld.getWorldType().getWindManager();
 
         float windDirection = theWind.getWindDirection(mc.theWorld, 0.0f, 500.0f, 0.0f) * 360f;
         float windIntensity = theWind.getWindIntensity(mc.theWorld, 0.0f, 500.0f, 0.0f);
@@ -37,7 +37,7 @@ public class TileEntityRendererFlag extends TileEntityRenderer<TileEntityFlag>
         doRender(tileEntity, x, y, z, partialTick, shortPole, windDirection, windIntensity);
     }
 
-    public void doRender(TileEntityFlag tileEntity, double x, double y, double z, float partialTick, boolean shortPole, float windDirection, float windIntensity)
+    public void doRender(FlagBlockEntity tileEntity, double x, double y, double z, float partialTick, boolean shortPole, float windDirection, float windIntensity)
     {
         if (flagRenderer == null)
         {
diff --git a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java b/src/main/java/net/minecraft/client/render/blockentity/FlowerJarBlockEntityRenderer.java
similarity index 80%
rename from src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
rename to src/main/java/net/minecraft/client/render/blockentity/FlowerJarBlockEntityRenderer.java
index 46cf8a00b..285508ad3 100644
--- a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
+++ b/src/main/java/net/minecraft/client/render/blockentity/FlowerJarBlockEntityRenderer.java
@@ -1,20 +1,20 @@
-package net.minecraft.client.render.tileentity;
+package net.minecraft.client.render.blockentity;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
-import net.minecraft.client.render.stitcher.TextureRegistry;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.entity.TileEntityFlowerJar;
+import net.minecraft.core.block.entity.FlowerJarBlockEntity;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.World;
 import org.lwjgl.opengl.GL11;
 
-public class TileEntityRendererFlowerJar extends TileEntityRenderer<TileEntityFlowerJar>{
+public class FlowerJarBlockEntityRenderer extends BlockEntityRenderer<FlowerJarBlockEntity> {
     private RenderBlocks renderBlocks;
     @Override
     public void onWorldChanged(World world)
@@ -22,12 +22,12 @@ public class TileEntityRendererFlowerJar extends TileEntityRenderer<TileEntityFl
         renderBlocks = new RenderBlocks(world);
     }
     @Override
-    public void doRender(Tessellator tessellator, TileEntityFlowerJar tileEntity, double x, double y, double z, float renderPartialTicks) {
+    public void doRender(Tessellator tessellator, FlowerJarBlockEntity tileEntity, double x, double y, double z, float renderPartialTicks) {
         GL11.glPushMatrix();
         if(tileEntity.flowerInPot > 0){
             GL11.glTranslatef((float)x, (float)y, (float)z);
             Block block = Block.getBlock(tileEntity.flowerInPot);
-            TextureRegistry.blockAtlas.bindTexture();
+            TextureRegistry.blockAtlas.bind();
             float scaleValue = 0.75F;
             GL11.glScalef(scaleValue, scaleValue, scaleValue);
             GL11.glTranslatef(0.66F, 0.75F, 0.66F);
diff --git a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMesh.java b/src/main/java/net/minecraft/client/render/blockentity/MeshBlockEntityRenderer.java
similarity index 75%
rename from src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMesh.java
rename to src/main/java/net/minecraft/client/render/blockentity/MeshBlockEntityRenderer.java
index f7c3f4c8a..2ce9fc9c6 100644
--- a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMesh.java
+++ b/src/main/java/net/minecraft/client/render/blockentity/MeshBlockEntityRenderer.java
@@ -1,5 +1,7 @@
-package net.minecraft.client.render.tileentity;
+package net.minecraft.client.render.blockentity;
 
+import net.minecraft.core.block.entity.GoldMeshBlockEntity;
+import net.minecraft.core.entity.ItemEntity;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
@@ -8,16 +10,15 @@ import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
-import net.minecraft.core.block.entity.TileEntityMeshGold;
-import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.util.helper.MathHelper;
+import org.lwjgl.opengl.GL12;
 
-public class TileEntityRendererMesh extends TileEntityRenderer<TileEntityMeshGold> {
+public class MeshBlockEntityRenderer extends BlockEntityRenderer<GoldMeshBlockEntity> {
 	
-	public EntityItem renderEntity = new EntityItem(null);
+	public ItemEntity renderEntity = new ItemEntity(null);
 	
     @Override
-    public void doRender(Tessellator tessellator, TileEntityMeshGold tileEntity, double x, double y, double z, float renderPartialTicks) {
+    public void doRender(Tessellator tessellator, GoldMeshBlockEntity tileEntity, double x, double y, double z, float renderPartialTicks) {
         if(tileEntity.filterItem == null) return;
         GL11.glPushMatrix();
 
@@ -34,11 +35,11 @@ public class TileEntityRendererMesh extends TileEntityRenderer<TileEntityMeshGol
         float lightLevel = Minecraft.getMinecraft(this).theWorld.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
         if (Global.accessor.isFullbrightEnabled()) lightLevel = 1.0f;
         BlockModel.setRenderBlocks(EntityRenderDispatcher.instance.itemRenderer.renderBlocksInstance);
-        GL11.glEnable(32826 /*GL_RESCALE_NORMAL_EXT*/);
+        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         GL11.glEnable(GL11.GL_BLEND);
         ItemModelDispatcher.getInstance().getDispatch(tileEntity.filterItem).renderAsItemEntity(Tessellator.instance, renderEntity, tileEntity.worldObj.rand, tileEntity.filterItem, 1, f3, lightLevel, renderPartialTicks);
         GL11.glDisable(GL11.GL_BLEND);
-        GL11.glDisable(32826 /*GL_RESCALE_NORMAL_EXT*/);
+        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
         GL11.glPopMatrix();
         
         renderEntity.world = null;
diff --git a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java b/src/main/java/net/minecraft/client/render/blockentity/MobSpawnerBlockEntityRenderer.java
similarity index 77%
rename from src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
rename to src/main/java/net/minecraft/client/render/blockentity/MobSpawnerBlockEntityRenderer.java
index b49ca0664..bea6ec1b3 100644
--- a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
+++ b/src/main/java/net/minecraft/client/render/blockentity/MobSpawnerBlockEntityRenderer.java
@@ -1,25 +1,24 @@
-package net.minecraft.client.render.tileentity;
+package net.minecraft.client.render.blockentity;
 
 import java.util.HashMap;
 import java.util.Map;
 
 import net.minecraft.client.render.EntityRenderDispatcher;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.block.entity.TileEntityMobSpawner;
+import net.minecraft.core.block.entity.MobSpawnerBlockEntity;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.world.World;
 import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
-//            TileEntitySpecialRenderer, TileEntityMobSpawner, Entity, EntityList, 
-//            RenderManager, TileEntity
+//            TileEntitySpecialRenderer, MobSpawnerBlockEntity, Entity, EntityList,
+//            RenderManager, BlockEntity
 
-public class TileEntityRendererMobSpawner extends TileEntityRenderer<TileEntityMobSpawner>
+public class MobSpawnerBlockEntityRenderer extends BlockEntityRenderer<MobSpawnerBlockEntity>
 {
 
-    public TileEntityRendererMobSpawner()
+    public MobSpawnerBlockEntityRenderer()
     {
         entityHashMap = new HashMap<>();
     }
@@ -29,7 +28,7 @@ public class TileEntityRendererMobSpawner extends TileEntityRenderer<TileEntityM
     }
 
     @Override
-	public void doRender(Tessellator tessellator, TileEntityMobSpawner mobSpawner, double x, double y, double z,
+	public void doRender(Tessellator tessellator, MobSpawnerBlockEntity mobSpawner, double x, double y, double z,
                          float partialTick)
     {
         GL11.glPushMatrix();
